# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class Template(pulumi.CustomResource):
    auto_delete_executions: pulumi.Output[bool]
    """
    When deleting a template, whether to delete its related executions. Default to `false`.
    """
    content: pulumi.Output[str]
    """
    The content of the template. The template must be in the JSON or YAML format. Maximum size: 64 KB. 
    """
    created_by: pulumi.Output[str]
    """
    The creator of the template.
    """
    created_date: pulumi.Output[str]
    """
    The time when the template is created.
    """
    description: pulumi.Output[str]
    """
    The description of the template.
    """
    has_trigger: pulumi.Output[bool]
    """
    Is it triggered successfully.
    """
    share_type: pulumi.Output[str]
    """
    The sharing type of the template. The sharing type of templates created by users are set to Private. The sharing type of common templates provided by OOS are set to Public.
    """
    tags: pulumi.Output[dict]
    """
    A mapping of tags to assign to the resource.
    """
    template_format: pulumi.Output[str]
    """
    The format of the template. The format can be JSON or YAML. The system automatically identifies the format.
    """
    template_id: pulumi.Output[str]
    """
    The id of OOS Template.
    """
    template_name: pulumi.Output[str]
    """
    The name of the template. The template name can be up to 200 characters in length. The name can contain letters, digits, hyphens (-), and underscores (_). It cannot start with `ALIYUN`, `ACS`, `ALIBABA`, or `ALICLOUD`.
    """
    template_type: pulumi.Output[str]
    """
    The type of OOS Template. `Automation` means the implementation of Alibaba Cloud API template, `Package` means represents a template for installing software.
    """
    template_version: pulumi.Output[str]
    """
    The version of OOS Template.
    """
    updated_by: pulumi.Output[str]
    """
    The user who updated the template.
    """
    updated_date: pulumi.Output[str]
    """
    The time when the template was updated.
    """
    version_name: pulumi.Output[str]
    """
    The name of template version.
    """
    def __init__(__self__, resource_name, opts=None, auto_delete_executions=None, content=None, tags=None, template_name=None, version_name=None, __props__=None, __name__=None, __opts__=None):
        """
        Provides a OOS Template resource. For information about Alicloud OOS Template and how to use it, see [What is Resource Alicloud OOS Template](https://www.alibabacloud.com/help/doc-detail/120761.htm).

        > **NOTE:** Available in 1.92.0+.



        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] auto_delete_executions: When deleting a template, whether to delete its related executions. Default to `false`.
        :param pulumi.Input[str] content: The content of the template. The template must be in the JSON or YAML format. Maximum size: 64 KB. 
        :param pulumi.Input[dict] tags: A mapping of tags to assign to the resource.
        :param pulumi.Input[str] template_name: The name of the template. The template name can be up to 200 characters in length. The name can contain letters, digits, hyphens (-), and underscores (_). It cannot start with `ALIYUN`, `ACS`, `ALIBABA`, or `ALICLOUD`.
        :param pulumi.Input[str] version_name: The name of template version.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['auto_delete_executions'] = auto_delete_executions
            if content is None:
                raise TypeError("Missing required property 'content'")
            __props__['content'] = content
            __props__['tags'] = tags
            if template_name is None:
                raise TypeError("Missing required property 'template_name'")
            __props__['template_name'] = template_name
            __props__['version_name'] = version_name
            __props__['created_by'] = None
            __props__['created_date'] = None
            __props__['description'] = None
            __props__['has_trigger'] = None
            __props__['share_type'] = None
            __props__['template_format'] = None
            __props__['template_id'] = None
            __props__['template_type'] = None
            __props__['template_version'] = None
            __props__['updated_by'] = None
            __props__['updated_date'] = None
        super(Template, __self__).__init__(
            'alicloud:oos/template:Template',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, auto_delete_executions=None, content=None, created_by=None, created_date=None, description=None, has_trigger=None, share_type=None, tags=None, template_format=None, template_id=None, template_name=None, template_type=None, template_version=None, updated_by=None, updated_date=None, version_name=None):
        """
        Get an existing Template resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] auto_delete_executions: When deleting a template, whether to delete its related executions. Default to `false`.
        :param pulumi.Input[str] content: The content of the template. The template must be in the JSON or YAML format. Maximum size: 64 KB. 
        :param pulumi.Input[str] created_by: The creator of the template.
        :param pulumi.Input[str] created_date: The time when the template is created.
        :param pulumi.Input[str] description: The description of the template.
        :param pulumi.Input[bool] has_trigger: Is it triggered successfully.
        :param pulumi.Input[str] share_type: The sharing type of the template. The sharing type of templates created by users are set to Private. The sharing type of common templates provided by OOS are set to Public.
        :param pulumi.Input[dict] tags: A mapping of tags to assign to the resource.
        :param pulumi.Input[str] template_format: The format of the template. The format can be JSON or YAML. The system automatically identifies the format.
        :param pulumi.Input[str] template_id: The id of OOS Template.
        :param pulumi.Input[str] template_name: The name of the template. The template name can be up to 200 characters in length. The name can contain letters, digits, hyphens (-), and underscores (_). It cannot start with `ALIYUN`, `ACS`, `ALIBABA`, or `ALICLOUD`.
        :param pulumi.Input[str] template_type: The type of OOS Template. `Automation` means the implementation of Alibaba Cloud API template, `Package` means represents a template for installing software.
        :param pulumi.Input[str] template_version: The version of OOS Template.
        :param pulumi.Input[str] updated_by: The user who updated the template.
        :param pulumi.Input[str] updated_date: The time when the template was updated.
        :param pulumi.Input[str] version_name: The name of template version.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["auto_delete_executions"] = auto_delete_executions
        __props__["content"] = content
        __props__["created_by"] = created_by
        __props__["created_date"] = created_date
        __props__["description"] = description
        __props__["has_trigger"] = has_trigger
        __props__["share_type"] = share_type
        __props__["tags"] = tags
        __props__["template_format"] = template_format
        __props__["template_id"] = template_id
        __props__["template_name"] = template_name
        __props__["template_type"] = template_type
        __props__["template_version"] = template_version
        __props__["updated_by"] = updated_by
        __props__["updated_date"] = updated_date
        __props__["version_name"] = version_name
        return Template(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

